# -*- coding: utf-8 -*-
import matplotlib.pyplot as plt
import csv

#fonction permettant de lire le fichier csv et de modifier la virgule par un point le cas échéant
def readColCSV(fichier,sep,n) :
    file=open(fichier,"r")
    reader=csv.reader(file,delimiter=sep)
    col=[]
    for row in reader :
        if(row[n][0].isdigit()) :
            notation_point=row[n].replace(",",".")
            col.append(float(notation_point))
    return col

#nom du fichier à traiter
fichier=input("Quel est le nom du fichier de pointage (sans l'extension .csv)?")+".csv"

#Appel de la fonction pour récupérer et lire les données.
t=readColCSV(fichier,";",0)
x=readColCSV(fichier, ";",1)
y=readColCSV(fichier, ";",2)

#Calcul des coordonnées Vx et Vy des vecteurs vitesse
Vx=[]
for i in range(len(x)-1) :
    Vx=Vx+[(x[i+1]-x[i])/(t[i+1]-t[i])]

Vy=[]
for i in range(len(y)-1) :
    Vy=Vy+[(y[i+1]-y[i])/(t[i+1]-t[i])]

#Calcul des coordonnées des vecteurs variation de vitesse et du produit m*Delta v/Delta t
DVx=[]
for i in range(len(Vx)-1) :
    DVx=DVx+[(Vx[i+1]-Vx[i])]

DVy=[]
for i in range(len(Vy)-1) :
    DVy=DVy+[(Vy[i+1]-Vy[i])]

DV=[]
for i in range(len(DVy)) :
    DV=DV+[0.600*(DVx[i]**2+DVy[i]**2)**0.5/(t[i+1]-t[i])]

#tracé des positions et des vecteurs variation vitesse
for i in range(len(t)-1):
    plt.plot(0,0,x[i],y[i],'ro')
    if i < len(t)-2:
        plt.arrow(x[i+1],y[i+1],DVx[i],DVy[i], color='b',head_width=0.1, head_length=0.10, length_includes_head=True)
        plt.text(x[i+1]+0.05,y[i+1]-0.15,'$\Delta \overrightarrow{v}_{%.i \mapsto %.i}$'%(i+1, i+2),color="blue")
        print('Au point',i+1, 'le produit m*Delta v/Delta t, vaut',round(DV[i],2),' kg. m/s²')
#Légende
plt.text(1.6,0.5,"Échelle :    1 m/s",  color="blue")
plt.plot([2,2],[0,1],'_-',color='blue')
plt.grid()
plt.title("Tracé des vecteurs variation de vitesse")
plt.xlabel('x (m)')
plt.ylabel('y (m)')
#tracé des points de la courbe
plt.savefig("Courbe-deltaV.png")
plt.show()
